﻿@model Avira.MarketingResearch.Model.ViewModels.QualitativeInfo.QualitativeGenerateTableCRUDViewModel
@using System.Web;
@using Microsoft.AspNetCore.Http
@using Newtonsoft.Json;
@using Avira.MarketingResearch.Model.ViewModels;
@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_LayoutWithoutLeftMenu.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<!-- begin #page-container -->
<!-- begin #content -->
<div id="content" class="content">
    <div class="col-md-4">
        <h4>Qualitative Add table Page</h4>
    </div>
    <div class="section-container section-with-top-border p-b-10">
        <div class="row">
            <div class="col-lg-6">
                <div class="clearfix">
                    <h5 class="m-t-0">Project Name: @ViewBag.ProjectName</h5>
                </div>
            </div>
            <div class="col-lg-6">
                <div class="clearfix">
                    <h5 class="m-t-0">Status: @ViewBag.StatusName</h5>
                </div>
            </div>
        </div>
        <form method="post" action="Index" name="frmGenerateTable">
            @Html.Hidden("ProjectId", Model.ProjectId)
            @Html.Hidden("Id", Model.Id)
            <table class="table table-td-valign-middle">
                <thead>
                    <tr>
                        <th>Table Name</th>
                        <th>Rows</th>
                        <th class="text-center">Columns</th>
                        <th class="text-center">Column Header</th>
                        <th class="text-center">Image</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td class="text-center">@Html.TextBoxFor(Model => Model.qualitativeGenerateTableViewModel.TableName, new { @class = "form-control" }) </td>
                        <td class="text-center">@Html.TextBoxFor(Model => Model.qualitativeGenerateTableViewModel.Rows, new { @class = "form-control" }) </td>
                        <td class="text-center">@Html.TextBoxFor(Model => Model.qualitativeGenerateTableViewModel.Columns, new { @class = "form-control" }) </td>
                        <td class="text-center">@Html.CheckBoxFor(Model => Model.qualitativeGenerateTableViewModel.IsHeaderRequired, new { @class = "form-control" })</td>
                        <td class="text-center visible=false">@Html.CheckBoxFor(Model => Model.qualitativeGenerateTableViewModel.IsImageRequired, new { @class = "form-control" })</td>
                        <td class="text-center"><button type="submit" name="actionName" value="GenerateTable" class="btn btn-grey m-b-5">Generate Table</button>  </td>
                    </tr>
                </tbody>
            </table>

            @*<table>
                    <tr>
                        @foreach (var header in Model.HeaderData)
                        {
                            <th  style='background-color: #C0C0C0;border: 1px solid #ccc'>
                             <input value='@header.Value' class ='form-control' type='text' name='@header.Key' id='@header.Key'>
                            </th>
                        }
                    </tr>
                    @{

                        var distnctRows = Model.TableData.Select(x => x.Key.Split('_')[0]).Distinct();
                        for(var rownum = 0; rownum < distnctRows.Count(); rownum++)
                        {
                                    <tr>
                                        @foreach (var header in Model.HeaderData)
                                        {

                                            var dataKey = rownum + "_" + header.Key.Split("_")[1].ToString();
                                            @foreach (var tableDataTD in Model.TableData.Where(x => x.Key.EndsWith(dataKey, StringComparison.OrdinalIgnoreCase)))
                                            {
                                            <td style='background-color: #D3D3D3;border: 1px solid #ccc'>
                                            <input value='@tableDataTD.Value' class='form-control' type='text' name='@tableDataTD.Key' id='@tableDataTD.Key'>
                                            </td>

                                            }
                                        }
                                    </tr>
                                }

                    }
                </table>*@







        </form>
        <br />
        <form method="post" id="frmTabledata" action="Index" name="frmTabledata">
            <div id="FormTable">
                @*@Html.TableDisplayFor()*@

                <table id='Table1' cellpadding='5' cellspacing='0'>
                    @Html.Hidden("ProjectId", Model.ProjectId)
                    @Html.Hidden("Id", Model.Id)
                    @if (Model != null)
                    {
                        @Html.Hidden("TableName", Model.qualitativeGenerateTableViewModel.TableName)
                        @Html.Hidden("Rows", Model.qualitativeGenerateTableViewModel.Rows)
                        @Html.Hidden("IsHeaderRequired", Model.qualitativeGenerateTableViewModel.IsHeaderRequired)
                        @Html.Hidden("Columns", Model.qualitativeGenerateTableViewModel.Columns)
                        @Html.Hidden("IsImageRequired", Model.qualitativeGenerateTableViewModel.IsImageRequired)
                        @Html.Raw(Model.qualitativeGenerateTableViewModel.TableHTML)
                        @*if (Model.qualitativeGenerateTableViewModel.IsImageRequired)
                            {
                                 <td style='background-color: #D3D3D3;border: 1px solid #ccc'><input name='file_" + r + "'  type='file' id='file_" + r + "'></td>");
                            }*@
                    }
                </table>
            </div>
            <br />
            <div class="section-with-top-border p-b-5">
                <div class="row">
                    <!-- begin col-6 -->
                    <div class="col-lg-6">
                        <div class="panel panel-info" data-sortable-id="ui-widget-8">
                            <div class="panel-heading">
                                <div class="panel-heading-btn">
                                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-white"
                                       data-click="panel-expand"><i class="fa fa-expand"></i></a>
                                </div>
                                <h4 class="panel-title">Author Notes <span class="text-danger">*</span></h4>
                            </div>
                            @*<textarea name="AuthorRemark" class="form-control no-rounded-corner" rows="6">@Model.QualitativeNoteViewModel.AuthorRemark</textarea>*@

                            @Html.TextAreaFor(model => model.QualitativeNoteViewModel.AuthorRemark, 4, 3, htmlAttributes: new { @class = "form-control no-rounded-corner" })

                            <script>
                                CKEDITOR.replace('QualitativeNoteViewModel.AuthorRemark', {
                                    toolbarGroups: [{
                                        "name": "basicstyles",
                                        "groups": ["basicstyles"]
                                    },
                                    {
                                        "name": "links",
                                        "groups": ["links"]
                                    },
                                    {
                                        "name": "paragraph",
                                        "groups": ["list", "blocks"]
                                    },

                                    {
                                        "name": "document",
                                        "groups": ["mode"]
                                    },
                                    {
                                        "name": "insert",
                                        "groups": ["insert"]
                                    },
                                    {
                                        "name": "styles",
                                        "groups": ["styles"]
                                    },
                                    {
                                        "name": "about",
                                        "groups": ["about"]
                                    }
                                    ],
                                    removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                                });
                            </script>

                        </div>
                    </div>
                    <!-- end col-6 -->
                    <!-- begin col-6 -->
                    <div class="col-lg-6">
                        <div class="panel panel-info" data-sortable-id="ui-widget-8">
                            <div class="panel-heading">
                                <div class="panel-heading-btn">
                                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-white"
                                       data-click="panel-expand"><i class="fa fa-expand"></i></a>
                                </div>
                                <h4 class="panel-title">Approver Notes</h4>
                            </div>

                            @*<textarea name="ApproverRemark" class="form-control no-rounded-corner" rows="6">@Model.QualitativeNoteViewModel.ApproverRemark </textarea>*@
                            @Html.TextAreaFor(model => model.QualitativeNoteViewModel.ApproverRemark, 4, 3, htmlAttributes: new { @class = "form-control no-rounded-corner" })

                            <script>
                                CKEDITOR.replace('QualitativeNoteViewModel.ApproverRemark', {
                                    toolbarGroups: [{
                                        "name": "basicstyles",
                                        "groups": ["basicstyles"]
                                    },
                                    {
                                        "name": "links",
                                        "groups": ["links"]
                                    },
                                    {
                                        "name": "paragraph",
                                        "groups": ["list", "blocks"]
                                    },

                                    {
                                        "name": "document",
                                        "groups": ["mode"]
                                    },
                                    {
                                        "name": "insert",
                                        "groups": ["insert"]
                                    },
                                    {
                                        "name": "styles",
                                        "groups": ["styles"]
                                    },
                                    {
                                        "name": "about",
                                        "groups": ["about"]
                                    }
                                    ],
                                    removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                                });
                            </script>
                        </div>
                    </div>
                </div>
                <!-- end row -->
            </div>
            <!-- end section-container -->
            <div class="section-with-top-border p-b-10">
                @if (Context.Session.GetString("DisplayName") != null)
                {
                    var Permissions = Context.Session.GetString("PermissionList");
                    var controllerName = this.ViewContext.RouteData.Values["controller"].ToString();
                    var PermissionList = JsonConvert.DeserializeObject<List<PermissionsByUserRoleIdViewModel.PermissionByRoleId>>(Permissions);
                    var permission = PermissionList.FirstOrDefault(x => x.PermissionName.Equals(controllerName));
                    var userRoleName = Context.Session.GetString("UserRoleName");

                    var IsAllowSubmit = PermissionList.Any(x => x.PermissionName.Equals("QualitativeFormSubmitButton", StringComparison.OrdinalIgnoreCase));
                    var IsAllowApprove = PermissionList.Any(x => x.PermissionName.Equals("QualitativeFormApproveButton", StringComparison.OrdinalIgnoreCase));
                    var IsAllowRejected = PermissionList.Any(x => x.PermissionName.Equals("QualitativeFormRejectedButton", StringComparison.OrdinalIgnoreCase));
                    var IsAllowSave = PermissionList.Any(x => x.PermissionName.Equals("QualitativeFormSaveButton", StringComparison.OrdinalIgnoreCase));
                    <div class="text-center">
                        <p>
                            <a class="btn btn-grey m-b-5" href=".html">Previous</a>
                            @Html.Hidden("ActionName", "")
                            <button type="button" id="btnSave" name="Save" @(IsAllowSave ? "" : "disabled") value="Save" class="btn btn-grey m-b-5">Save</button>
                            <button type="button" class="btn btn-grey m-b-5">Clear</button>
                            <button type="button" @(IsAllowSubmit ? "" : "disabled") class="btn btn-grey m-b-5">Submit</button>
                            <button type="button" @(IsAllowApprove ? "" : "disabled") class="btn btn-grey m-b-5">Approve</button>
                            <button type="button" @(IsAllowRejected ? "" : "disabled") class="btn btn-grey m-b-5">Reject</button>
                            <button type="button" class="btn btn-grey m-b-5">Next</button>
                        </p>
                    </div>
                }
            </div>
        </form>
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function () {

        $("#btnSave").click(function () {
            $("#ActionName").val("Save");
            var myJSON = JSON.stringify($('#frmTabledata').serializeArray());
            saveData(myJSON);

            //$.post("/QualitativeAddTable/PostData", { json: myJSON }, function (data) {
            //    if (data.isSuccess == true) {
            //        alert(data)
            //        window.location = "/QualitativeAddTable/Index?Id=" + data.id + "&ProjectId=" + data.projectId;
            //    }
            //});
        }
        );


        //$("#Save").click(function () {
        //    debugger;
        //    $("#ActionName").val("Save");
        //    var myJSON = JSON.stringify($('#frmTabledata').serializeArray());
        //    //alert(myJSON)
        //    debugger;
        //    //saveData(myJSON);

        //    //$.post("/QualitativeAddTable/PostData", { json: myJSON }, function (data) {
        //    //    if (data.isSuccess == true) {
        //    //        alert(data)
        //    //        window.location = "/QualitativeAddTable/Index?Id=" + data.id + "&ProjectId=" + data.projectId;
        //    //    }
        //    //});

        //});

        function saveData(myJSON) {
         $.ajax({
                type: "POST",
                url: '/QualitativeAddTable/PostData',
                data: { json: myJSON },
                success: function (data) {
                    if (data.isSuccess == true) {
                        alert(data.message);
                        window.location = "/QualitativeAddTable/Index?Id=" + data.id + "&ProjectId=" + '@Model.ProjectId';
                    }
                    else {
                        alert(data.message);
                    }
                    //return true;
                },
                error: function (xhr, data) {
                    alert('Error while processing your request.');
                }
            });
    }
    });



</script>